Attribute VB_Name = "Module1"
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Const SRCCOPY = &HCC0020         ' (DWORD) dest = source
Public Const SRCINVERT = &H660046       ' (DWORD) dest = source XOR dest
Public Const SRCPAINT = &HEE0086        ' (DWORD) dest = source OR dest
Public Const SRCAND = &H8800C6          ' (DWORD) dest = source AND dest

Public Gehege As New Collection
Public Sub zeichneSchaf(Gehege As Collection, desthdc As Long, srchdc As Long)
    Dim Schaf As SchafClass
    Dim d As Integer
    'Kontrolliere die Richtung der Schafe in Grad
    'Sorgen das das Gesicht des Schafes vom Mauszeiger wegdreht
    For Each Schaf In Gehege
        Select Case Int(((Schaf.Richtung + 1.68) * 180) / 3.14)
            Case 0 To 45: d = 2
            Case 45 To 90: d = 3
            Case 90 To 135: d = 4
            Case 135 To 180: d = 5
            Case 180 To 225: d = 6
            Case 225 To 270: d = 7
            Case 270 To 315: d = 0
            Case 315 To 360: d = 1
        End Select
        ' d bestimmt welches Schaf aus Picspr.Picture verwendet werden soll
        u& = BitBlt(desthdc, Schaf.x, Schaf.y, 20, 20, srchdc, d * 20, 40, SRCAND)
        u& = BitBlt(desthdc, Schaf.x, Schaf.y, 20, 20, srchdc, d * 20, 20 * Schaf.colour, SRCINVERT)
    Next
    Set Schaf = Nothing
End Sub
Public Sub addSchaf(Gehege As Collection, x As Integer, y As Integer, colour As Integer)
' Ein Schaf ins Gehege einfgen
    Dim Schaf As SchafClass
    Set Schaf = New SchafClass
    Schaf.x = x
    Schaf.y = y
    Schaf.colour = colour
    Schaf.id = Gehege.Count
    Gehege.Add Schaf
    Set Schaf = Nothing
End Sub
Public Function Gefangen(Gehege As Collection) As Boolean
'Finde heraus ob alle Schafe richtig gefangen sind
    Dim Schaf As SchafClass
    Dim fangflag As Boolean
    fangflag = True
    ' Wenn Sich alle Schafe in den richtigen Koordinaten der Fangflche
    ' befinden, liefert diese Funktion TRUE
    For Each Schaf In Gehege
        If Schaf.colour = 0 Then
            ' Weies Feld
            If Schaf.x < 45 Or Schaf.x > 119 Then fangflag = False
            If Schaf.y < 214 Or Schaf.y > 283 Then fangflag = False
        Else
            ' Lila Feld
            If Schaf.x < 201 Or Schaf.x > 274 Then fangflag = False
            If Schaf.y < 214 Or Schaf.y > 283 Then fangflag = False
        End If
        If fangflag = False Then Exit For
    Next
    Gefangen = fangflag
End Function
Public Sub BewegSchaf(Gehege As Collection, x As Integer, y As Integer)
' X und Y sind ist die aktuelle Mausposition
    Dim Abstand As Integer
    Dim Schaf As SchafClass, anderesSchaf As SchafClass
    'Schaf luft weg
    For Each Schaf In Gehege
        'Abstand Maus - Schaf kontrollieren
        Abstand = Sqr((Schaf.x - x) ^ 2 + (Schaf.y - y) ^ 2)
        'Umso nher man kommt umso schneller mu das Schaf reagieren.
        'Berechnung des Vektors fr die Fluchtrichtung
        If x - Schaf.x = 0 Then
            'wegen "divide by zero"
            If y < Schaf.y Then Schaf.Richtung = 0 Else Schaf.Richtung = 3.14
        Else
            'Gradzahl bestimmen mit ATN (invers tangens)
            Schaf.Richtung = Atn((y - Schaf.y) / (x - Schaf.x))
            If Schaf.x < x Then Schaf.Richtung = Schaf.Richtung + 3.14
        End If
        If Abstand < 50 And Abstand > 0 Then
            'Wenn Schaf innerhalb des Abstands dann soll es weg rennen
            '*********************************************************
            ' Durch Vernderung der 4 bei "Int(Rnd(1) * 4)"
            ' In den zwei folgenden Anweisungen kann die
            ' Geschwindigkeit eingestellt werden.
            ' Abhngig von der Schnellheit der CPU !
            ' Umso hher der Wert umso schneller die Schafe
            ' Mit diesem Wert knnten auch einfache verschiedener
            ' Schwirigkeitsgrade realisiert werden
            '*********************************************************
            Schaf.x = Schaf.x - (x - Schaf.x) / (Abstand / (Int(Rnd(1) * 4) + 1))
            Schaf.y = Schaf.y - (y - Schaf.y) / (Abstand / (Int(Rnd(1) * 4) + 1))
        End If
    Next
    'berlappende Schafe vermeiden
    For Each Schaf In Gehege
        'Kontrolle ob zwei Schafe auf dem selben Platz stehen
        For Each anderesSchaf In Gehege
            If Schaf.id <> anderesSchaf.id Then 'Solange es nicht sich selber ist
                Abstand = 1 + Sqr((Schaf.x - anderesSchaf.x) ^ 2 + (Schaf.y - anderesSchaf.y) ^ 2)
                If Abstand < 10 Then
                    'Wenn Schaf zu dicht ist soll es wegspringen
                    Schaf.x = Schaf.x - (x - Schaf.x) / (Abstand / (Int(Rnd(1) * 2) + 0.5))
                    Schaf.y = Schaf.y - (y - Schaf.y) / (Abstand / (Int(Rnd(1) * 2) + 0.5))
                End If
            End If
        Next
    Next
    Set Schaf = Nothing
End Sub
